



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Servlet &amp; JSP - Filter</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Servlet &amp; JSP - Filter</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 02:42:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>过滤器可以对用户的请求拦截，进行预处理操作，接着将请求交给 Servlet 处理并生成响应，最后再对响应拦截，进行后处理操作。过滤器应用的场景有：用户登录、加密解密、会话校验等。</p>
<h2>Filter API</h2>
<p>过滤器必须继承 javax.servlet.Filter 接口。Filter 接口暴露三个生命周期方法：init、doFilter 和 destroy。</p>
<p>init: &nbsp;当容器将过滤器引入服务的时候（通常是应用启动的时候），init 方法会被调用。Servlet 容器调用 init 方法时会传入一个&nbsp;javax.servlet.FilterConfig 参数。FilterConfig 包含了过滤器的配置信息，如过滤器的名称、初始化参数、上下文环境等。</p>
<p>doFilter: 当过滤器关联的资源被请求时，doFilter 方法会被调用。doFilter 方法接收三个参数：ServletRequest、ServletResponse 和 FilterChain。ServletRequest 和&nbsp;ServletResponse 是被拦截的请求和响应对象，我们可以对其做一些处理，如对请求设置属性或者在响应添加 HTTP 首部，甚至是使用装饰器来改变请求和响应的行为。调用 FilterChain 的 doFilter 方法将请求和响应传递至过滤器链的下一个过滤器或目标资源。在 filterChain.doFilter(request, response) 方法调用之前的操作是预处理，在&nbsp;&nbsp;filterChain.doFilter(request, response) 方法调用之后的操作是后处理。</p>
<p>destroy: 当容器将过滤器移出服务的时候（通常是应用停止的时候），destroy 方法会被调用。</p>
<h2>配置过滤器</h2>
<p>1. 使用部署描述符配置：</p>
<div>
<pre class="prettyprint linenums">&lt;filter&gt;<br />
    &lt;filter-name&gt;myFilter&lt;/filter-name&gt;<br />
    &lt;filter-class&gt;com.huey.hello.filters.MyFilter&lt;/filter-class&gt;<br />
&lt;/filter&gt;<br />
&lt;filter-mapping&gt;<br />
    &lt;filter-name&gt;myFilter&lt;/filter-name&gt;<br />
    &lt;url-pattern&gt;/*&lt;/url-pattern&gt;<br />
&lt;/filter-mapping&gt;</pre>
</div>
<p>2. 在 Servlet3.0 可以使用&nbsp;@WebFilter 注解配置：</p>
<div>
<pre class="prettyprint linenums">@WebFilter(filterName = "myFilter", urlPatterns = {"/*"})<br />
public class MyFilter implements Filter {<br />
    // ...<br />
}</pre>
</div>
<h2>过滤器的作用顺序</h2>
<p>当多个过滤器作用在同一资源时，过滤器的作用顺序由其在部署描述符中的声明顺序决定，使用&nbsp;@WebFilter 注解无法指定作用顺序。假设有 Filter1 和 Filter2 作用在同一个资源，且 Filter1 在 Filter2 之前声明，那么作用顺序为：Filter1 的预处理 ---&gt;&nbsp;Filter2 的预处理&nbsp;---&gt; 目标资源的处理 ---&gt;&nbsp;Filter2 的后处理 ---&gt;&nbsp;Filter1 的后处理。</p>
<h2>应用示例</h2>
<div>
<pre class="prettyprint linenums">package com.huey.hello.filters;

import java.io.IOException;

import javax.servlet.Filter;<br />
import javax.servlet.FilterChain;<br />
import javax.servlet.FilterConfig;<br />
import javax.servlet.ServletException;<br />
import javax.servlet.ServletRequest;<br />
import javax.servlet.ServletResponse;<br />
import javax.servlet.annotation.WebFilter;<br />
import javax.servlet.annotation.WebInitParam;<br />
import javax.servlet.http.HttpServletRequest;

import com.huey.hello.wrapper.CharsetServletRequestWrapper;

/**<br />
 * 使用注解配置 Filter<br />
 * urlPatterns 配置关联的目标资源<br />
 * initParams 配置初始参数<br />
 */<br />
@WebFilter(filterName="charsetFilter", urlPatterns = {"/*"},<br />
        initParams = {<br />
                @WebInitParam(name = "oldCharset", value = "ISO-8859-1"),<br />
                @WebInitParam(name = "newCharset", value = "UTF-8"),<br />
        })<br />
public class CharsetFilter implements Filter {

    private String oldCharset;<br />
    private String newCharset;

    @Override<br />
    public void init(FilterConfig filterConfig) throws ServletException {<br />
        oldCharset = filterConfig.getInitParameter("oldCharset");<br />
        newCharset = filterConfig.getInitParameter("newCharset");<br />
    }

    @Override<br />
    public void destroy() {<br />
    }

    @Override<br />
    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)<br />
            throws IOException, ServletException {<br />
        request.setCharacterEncoding(newCharset);<br />
        response.setContentType("text/plain;charset=" + newCharset);

        HttpServletRequest httpRequest = (HttpServletRequest) request;<br />
        CharsetServletRequestWrapper requestWrapper = new CharsetServletRequestWrapper(httpRequest, oldCharset, newCharset);<br />
        chain.doFilter(requestWrapper, response);<br />
    }

}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r4oyd8.html">Odoo中本日、本月、上月过滤器实现方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kv1l39.html">grep查询文本：问一个简单shell问题，将grep的输出赋值给一个变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rwelrq.html">QT5 动态链接库的创建和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmvnk8.html">&lbrack;分享&rsqb; WIN7x64封装体积小于4G制作过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rjyod8.html">Yii源码阅读笔记（十八）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdk0r48.html">R12 - OM改进了对成本与收入确认的流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wv1zvq.html">C&num;- 基于Lumisoft&period;NET组件的POP3邮件接管和删除操纵</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0r1d4q.html">iOS越狱系列（一）：使用Reveal分析APP</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1noy19.html">自动文档摘要评价方法：Edmundson，ROUGE</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1z0528.html">技术型创业者easy遇到的三大问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j044wgq.html">Rational rose下载，安装，破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1nwlx9.html">剑指offer-面试题14&period;调整数组顺序使奇数位于偶数的前面</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kzr659.html">nodejs之防jade</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kp6609.html">Valgrind使用记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj0g5xq.html">11个超棒的iOS开发学习网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1z15dq.html">MySQL1：客户端&sol;服务器架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g2vyq.html">ubantu10&period;04安装ns-2&period;34</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rmg5j9.html">GUI学习之八&mdash;&mdash;复选框QCheckBox的学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjje079.html">vue学习-自动行合并的table</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o7kpj8.html">Nginx&plus;Tomcat-cluster构建</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdekld79.html">javascript中字符串的trim功能表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnkzw0q.html">delphi 窗口最大化后控件的大小变化怎么设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1w0gj8.html">获取ie浏览器版本号</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydgx3xq.html">upload&period;php ---&amp;gt&semi;文件上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmg0609.html">关于java的continue、break关键字用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmvd6x9.html">AngularJS~大话开篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjg5zk9.html">Navicat for mysql 11&period;0破解方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvkyrxq.html">StructureMap 学习笔记&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0l330q.html">delphi 立即显示提示</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yd00jq.html">delphi 去掉TreeView水平滚动条</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
